require 'rails'
require_relative 'middleware_timer/version'
require_relative 'middleware_timer/timer'

module ::Rails
  module MiddlewareTimer
    module_function

    def time!
      ::Rails.configuration.middleware.middlewares.each do |klass|
        klass = klass.name.constantize
        if klass.respond_to?(:prepend)
          klass.prepend(Rails::MiddlewareTimer::Timer)
        end
      end
    end
  end
end
