module Rails
  module MiddlewareTimer
    module Timer
      def call(env)
        start_time = Time.now
        response = super(env)
        end_time = Time.now
        time_taken = (1_000 * (end_time - start_time)).round
        class_name = self.class.name
        Rails::MiddlewareTimer::Timer.output(class_name, time_taken)
        response
      end

      module_function

      def output(class_name, time_taken)
        if respond_to?(:custom_output)
          custom_output(class_name, time_taken)
        else
          puts "#{class_name}#call took #{time_taken} ms"
        end
      end
    end
  end
end
